lib = File.expand_path('../lib', __FILE__)

$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)

require 'dash_overlord/version'

Gem::Specification.new do |gem|
  gem.name = "dash_overlord"
  gem.version = DashOverlord::VERSION
  gem.license = "NONE"
  gem.authors = ["StreetBees Dev Team"]
  gem.email = "dev@streetbees.com"
  gem.summary = "2Mundo business logic"
  gem.description = "Ruby gem with all of the business logic, agnostic to protocols like HTTP, AMQP, etc."
  gem.homepage = "https://github.com/streetbees/dashlord/dash_lord"

  gem.files = `git ls-files`.split($/)
  gem.executables = gem.files.grep(%r{^bin/}).map{ |f| File.basename(f) }
  gem.test_files = gem.files.grep(%r{^(test|spec|features)/})
  gem.require_paths = ['lib']

  gem.add_development_dependency 'rake', '10.0.0'
  gem.add_development_dependency 'rspec', '3.4.0'
  gem.add_development_dependency 'pry-byebug', '3.3.0'
  gem.add_development_dependency 'systematize', '0.1.0'
  gem.add_development_dependency 'factory_girl', '4.7.0'
  gem.add_development_dependency 'database_cleaner', '1.5.1'

  gem.add_runtime_dependency 'pg', '>= 0.17'
  gem.add_runtime_dependency 'i18n', '>= 0.7.0'
  gem.add_runtime_dependency 'dotenv', '>= 2.1.1'
  gem.add_runtime_dependency 'bcrypt', '>= 2.0.0'
  gem.add_runtime_dependency 'aws-sdk', '>= 2.2.35'
  gem.add_runtime_dependency 'ransack', '>= 1.7.0'
  gem.add_runtime_dependency 'kaminari', '>= 1.0.0.rc1'
  gem.add_runtime_dependency 'elasticord', '>= 1.0.0'
  gem.add_runtime_dependency 'activerecord', '>= 3'
  gem.add_runtime_dependency 'object_attorney', '>= 3.0.7'
end
