require 'spec_helper'
require 'support/shared_missing_user'

describe DashOverlord::UseCases::V1::Videos::Index::Base do
  def make_the_call(params = nil)
    @context = described_class.perform \
      (params || {}).merge({ session: user_session })

    raise_context_unknown_error @context

    @response = app_response @context
  end

  include_examples 'authenticated user use_case'

  context 'when current_user exists' do
    before { @current_user = create('v1/user', :unilever) }

    context 'when no bee_videos are available' do
      before { make_the_call }

      it 'response.status should return 200' do
        expect(@response.http_status).to be 200
      end

      it 'should return pagination meta_data' do
        expect(@response.data).to match a_hash_including({
          'meta' => a_hash_including({
            'page' => 1,
            'per_page'=> 10,
            'total_pages' => 0,
            'total_results' => 0
          }),
          'data' => []
        })
      end
    end
  end
end
