require 'spec_helper'

describe DashOverlord::UseCases::V1::Videos::Index::Base,
         dynamodb: true do

  def search_adapter
    DashOverlord::UseCases::V1::Videos::Index::DynamoDb::Base
  end

  def make_the_call(params = nil)
    @context = described_class.perform \
      (params || {}).merge({
        search_adapter_use_case: search_adapter,
        session: user_session
      })

    raise_context_unknown_error @context
  end

  before(:all) do
    # migration = DashOverlord::Models::V1::DynamoDb::Migration.new \
    #   DashOverlord::Models::V1::DynamoDb::Video

    # migration.create!

  end

  after(:all) do
    # migration = DashOverlord::Models::V1::DynamoDb::Migration.new \
    #   DashOverlord::Models::V1::DynamoDb::Video

    # migration.delete!
  end

  let(:number_of_records) { 20 }

  def build_answer
    {
      "url": "https://s3-eu-west-1.amazonaws.com/streetbees-assets/dashboards/home_selfie/videos_1/11264-kitchen.MOV",
      "original_url": "https://streetbees-photos.s3-eu-west-1.amazonaws.com/uploads/bee_videos/temporary/original_11264-kitchen.jpg",
      "subtitle_url": "/subtitles//unilever/hhc/11264-kitchen.en.vtt",
      "country": ["UK", "US", "PT", "GB"].sample,
      "category": "Kitchen floor",
      "extra": nil,
      "segment_uid": "hhc",
      "lsm": "13+",
      "age": nil,
      "room": "Kitchen",
      "gender": ["Male", "Female"].sample,
      "user_id": 835,
      "children": true,
      "age_group": "46+",
      "household_members": 3,
      "household_members_group": nil
    }
  end

  def create_answers
    @videos = number_of_records.times.map do |index|
      build_answer.merge(
        "id" => (index + 1),
        "dashboard_id": 1
      )
    end

    DashOverlord::Models::V1::DynamoDb::Video.create_all \
      @videos
  end

  # context 'when no filter params are used' do
  #   before do
  #     @current_user = create('v1/user', :unilever)

  #     create_answers

  #     make_the_call
  #   end

  #   it '@context.status should be ok' do
  #     expect(@context.status).to eq 'ok'
  #   end

  #   it 'should have the right ammount of data' do
  #     expect(DashOverlord::Models::V1::DynamoDb::Video.all.count) \
  #       .to eq(20)
  #   end

  #   it 'should return pagination meta_data' do
  #     expect(@context.meta.page).to be 1
  #     expect(@context.meta.per_page).to be 10
  #   end

  #   it 'should return 10 results' do
  #     expect(@context.videos.length).to be 10
  #   end
  # end

  # context 'when filtering by page = 0' do
  #   before do
  #     @current_user = create('v1/user', :unilever)

  #     create_answers

  #     make_the_call page: 0
  #   end

  #   it '@context.status should be ok' do
  #     expect(@context.status).to eq 'ok'
  #   end

  #   it 'should return pagination meta_data' do
  #     expect(@context.meta.page).to be 0
  #     expect(@context.meta.per_page).to be 0
  #   end

  #   it 'should return 20 results', :cana do
  #     expect(@context.videos.length).to be 20
  #   end
  # end

  # context 'when filtering by something' do
  #   before do
  #     @current_user = create('v1/user', :unilever)

  #     create_answers

  #     @female_videos = @videos.select{|el| el[:gender] == "Female" }

  #     make_the_call \
  #       filter_query: {
  #         gender_eq: 'Female'
  #       }
  #   end

  #   it '@context.status should be ok' do
  #     expect(@context.status).to eq 'ok'
  #   end

  #   it 'should return pagination meta_data' do
  #     expect(@context.meta.page).to be 1
  #     expect(@context.meta.per_page).to be 10
  #   end

  #   it 'should return only filtered results', :focusrite do
  #     expect(@context.videos.length).to be @female_videos.count
  #   end
  # end
end
