ENV['ENV'] = 'test'

require File.expand_path('../../config/boot', __FILE__)

require 'pry-byebug'
require 'factory_girl'
require 'database_cleaner'

Dir[File.expand_path('../**/support/**/*.rb', __FILE__)].each do |file|
  require file
end

Elasticord::Config.set(:log, false)
Elasticord::Config.set(:index_namespace, ENV['ENV'])

# I guess either "FactoryGirl" or "DatabaseCleaner" needs this line bellow
ActiveRecord::Base.establish_connection DashOverlord::V1::Config.get(:db_config)

RSpec.configure do |config|
  config.include Helpers
  config.include FactoryGirl::Syntax::Methods

  config.run_all_when_everything_filtered = true
  config.filter_run_excluding quota_rules_full_example: true

  config.order = 'random'

  config.before(:suite) do
    DatabaseCleaner.strategy = :truncation
  end

  config.before(:each) do
    DatabaseCleaner.start
  end

  config.after(:each) do
    DatabaseCleaner.clean
  end

  BCrypt::Engine.cost = 1
end

Dir[File.expand_path('../**{,/*/**}/factories', __FILE__)].each do |factory_dir|
  FactoryGirl.definition_file_paths << factory_dir
end

FactoryGirl.find_definitions
