shared_examples 'authenticated admin use_case' do
  context 'when current_admin is not present' do
    before do
      make_the_call nil
    end

    it 'response.http_status should return 401' do
      expect(@response.http_status).to be 401
    end

    it 'response.data should return a 401 message' do
      expect(@response.data).to match a_hash_including({
        'code' => 401,
        'message' => I18n.t('v1.admins.not_logged_in'),
        'status' => 'unauthorized'
      })
    end
  end

  context 'when current_admin does not exist' do
    before do
      @current_admin = OpenStruct.new id: 666

      make_the_call nil
    end

    it 'response.http_status should return 401' do
      expect(@response.http_status).to be 401
    end

    it 'response.data should return a 401 message' do
      expect(@response.data).to match a_hash_including({
        'code' => 401,
        'message' => I18n.t('v1.admins.not_logged_in'),
        'status' => 'unauthorized'
      })
    end
  end
end
